package io.openim.flutter_openim_sdk.manager;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.openim.flutter_openim_sdk.listener.OnBaseListener;
import io.openim.flutter_openim_sdk.listener.OnChannelListener;
import open_im_sdk.Open_im_sdk;

public class ChannelManager extends BaseManager {

    public void setChannelListener(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.setChannelListener(new OnChannelListener());

        result.success(null);
    }


    public void getChannelMembersInfo(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.getSpecifiedChannelMembersInfo(
                new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                value(methodCall, "channelID"),
                jsonValue(methodCall, "userIDList")
        );
    }

    public void getChannelMemberList(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.getChannelMemberList(
                new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                value(methodCall, "channelID"),
                value(methodCall, "filter"),
                value(methodCall, "offset"),
                value(methodCall, "count")
        );
    }


    public void getChannelsInfo(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.getSpecifiedChannelsInfo(
                new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                jsonValue(methodCall, "channelIDList")
        );
    }

    public void joinChannel(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.joinChannel(
                new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                value(methodCall, "channelID"),
                value(methodCall, "reason"),
                value(methodCall, "joinSource"),
                value(methodCall, "ex")
        );
    }

    public void quitChannel(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.quitChannel(
                new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                value(methodCall, "channelID")
        );
    }



    public void changeChannelMute(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.changeChannelMute(
                new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                value(methodCall, "channelID"),
                value(methodCall, "mute")
        );
    }

    public void changeChannelMemberMute(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.changeChannelMemberMute(
                new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                value(methodCall, "channelID"),
                value(methodCall, "userID"),
                int2long(methodCall, "seconds")
        );
    }



    public void isJoinChannel(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.isJoinChannel(new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                value(methodCall, "channelID")
        );
    }

    public  void getUsersInChannel(MethodCall methodCall, MethodChannel.Result result) {
        Open_im_sdk.getUsersInChannel(new OnBaseListener(result, methodCall),
                value(methodCall, "operationID"),
                value(methodCall, "channelID"),
                jsonValue(methodCall, "userIDs")
        );
    }
}