import 'package:flutter_openim_sdk/flutter_openim_sdk.dart';

import '../models/channel_info.dart';

/// Channel Listener
class OnChannelListener {

  Function(ChannelInfo info)? onChannelDismissed;
  Function(ChannelInfo info)? onChannelInfoChanged;
  Function(ChannelMembersInfo info)? onChannelMemberAdded;
  Function(ChannelMembersInfo info)? onChannelMemberDeleted;
  Function(ChannelMembersInfo info)? onChannelMemberInfoChanged;
  Function(ChannelInfo info)? onJoinedChannelAdded;
  Function(ChannelInfo info)? onJoinedChannelDeleted;

  OnChannelListener({
    this.onChannelDismissed,
    this.onChannelInfoChanged,
    this.onChannelMemberAdded,
    this.onChannelMemberDeleted,
    this.onChannelMemberInfoChanged,
    this.onJoinedChannelAdded,
    this.onJoinedChannelDeleted,
  });


  void channelDismissed(ChannelInfo info) {
    onChannelDismissed?.call(info);
  }

  /// Channel information changed
  void channelInfoChanged(ChannelInfo info) {
    onChannelInfoChanged?.call(info);
  }

  /// Channel member added
  void channelMemberAdded(ChannelMembersInfo info) {
    onChannelMemberAdded?.call(info);
  }

  /// Channel member deleted
  void channelMemberDeleted(ChannelMembersInfo info) {
    onChannelMemberDeleted?.call(info);
  }

  /// Channel member information changed
  void channelMemberInfoChanged(ChannelMembersInfo info) {
    onChannelMemberInfoChanged?.call(info);
  }

  /// Joined channel added
  void joinedChannelAdded(ChannelInfo info) {
    onJoinedChannelAdded?.call(info);
  }

  /// Joined channel deleted
  void joinedChannelDeleted(ChannelInfo info) {
    onJoinedChannelDeleted?.call(info);
  }
}
